/**
 * Garage Administration API v0+garage-v0.9.0
 * Administrate your Garage cluster programatically, including status, layout, keys, buckets, and maintainance tasks.  *Disclaimer: The API is not stable yet, hence its v0 tag. The API can change at any time, and changes can include breaking backward compatibility. Read the changelog and upgrade your scripts before upgrading. Additionnaly, this specification is very early stage and can contain bugs, especially on error return codes/types that are not tested yet. Do not expect a well finished and polished product!* 
 *
 * The version of the OpenAPI document: v0.9.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import BucketInfoQuotas from './BucketInfoQuotas';
import BucketInfoWebsiteConfig from './BucketInfoWebsiteConfig';
import BucketKeyInfo from './BucketKeyInfo';

/**
 * The BucketInfo model module.
 * @module model/BucketInfo
 * @version v0.9.0
 */
class BucketInfo {
    /**
     * Constructs a new <code>BucketInfo</code>.
     * @alias module:model/BucketInfo
     */
    constructor() { 
        
        BucketInfo.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>BucketInfo</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BucketInfo} obj Optional instance to populate.
     * @return {module:model/BucketInfo} The populated <code>BucketInfo</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new BucketInfo();

            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('globalAliases')) {
                obj['globalAliases'] = ApiClient.convertToType(data['globalAliases'], ['String']);
            }
            if (data.hasOwnProperty('websiteAccess')) {
                obj['websiteAccess'] = ApiClient.convertToType(data['websiteAccess'], 'Boolean');
            }
            if (data.hasOwnProperty('websiteConfig')) {
                obj['websiteConfig'] = BucketInfoWebsiteConfig.constructFromObject(data['websiteConfig']);
            }
            if (data.hasOwnProperty('keys')) {
                obj['keys'] = ApiClient.convertToType(data['keys'], [BucketKeyInfo]);
            }
            if (data.hasOwnProperty('objects')) {
                obj['objects'] = ApiClient.convertToType(data['objects'], 'Number');
            }
            if (data.hasOwnProperty('bytes')) {
                obj['bytes'] = ApiClient.convertToType(data['bytes'], 'Number');
            }
            if (data.hasOwnProperty('unfinishedUploads')) {
                obj['unfinishedUploads'] = ApiClient.convertToType(data['unfinishedUploads'], 'Number');
            }
            if (data.hasOwnProperty('quotas')) {
                obj['quotas'] = BucketInfoQuotas.constructFromObject(data['quotas']);
            }
        }
        return obj;
    }


}

/**
 * @member {String} id
 */
BucketInfo.prototype['id'] = undefined;

/**
 * @member {Array.<String>} globalAliases
 */
BucketInfo.prototype['globalAliases'] = undefined;

/**
 * @member {Boolean} websiteAccess
 */
BucketInfo.prototype['websiteAccess'] = undefined;

/**
 * @member {module:model/BucketInfoWebsiteConfig} websiteConfig
 */
BucketInfo.prototype['websiteConfig'] = undefined;

/**
 * @member {Array.<module:model/BucketKeyInfo>} keys
 */
BucketInfo.prototype['keys'] = undefined;

/**
 * @member {Number} objects
 */
BucketInfo.prototype['objects'] = undefined;

/**
 * @member {Number} bytes
 */
BucketInfo.prototype['bytes'] = undefined;

/**
 * @member {Number} unfinishedUploads
 */
BucketInfo.prototype['unfinishedUploads'] = undefined;

/**
 * @member {module:model/BucketInfoQuotas} quotas
 */
BucketInfo.prototype['quotas'] = undefined;






export default BucketInfo;

