/**
 * Garage Administration API v0+garage-v0.9.0
 * Administrate your Garage cluster programatically, including status, layout, keys, buckets, and maintainance tasks.  *Disclaimer: The API is not stable yet, hence its v0 tag. The API can change at any time, and changes can include breaking backward compatibility. Read the changelog and upgrade your scripts before upgrading. Additionnaly, this specification is very early stage and can contain bugs, especially on error return codes/types that are not tested yet. Do not expect a well finished and polished product!* 
 *
 * The version of the OpenAPI document: v0.9.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import ClusterLayout from './ClusterLayout';
import NodeNetworkInfo from './NodeNetworkInfo';

/**
 * The GetNodes200Response model module.
 * @module model/GetNodes200Response
 * @version v0.9.0
 */
class GetNodes200Response {
    /**
     * Constructs a new <code>GetNodes200Response</code>.
     * @alias module:model/GetNodes200Response
     * @param node {String} 
     * @param garageVersion {String} 
     * @param garageFeatures {Array.<String>} 
     * @param rustVersion {String} 
     * @param dbEngine {String} 
     * @param knownNodes {Array.<module:model/NodeNetworkInfo>} 
     * @param layout {module:model/ClusterLayout} 
     */
    constructor(node, garageVersion, garageFeatures, rustVersion, dbEngine, knownNodes, layout) { 
        
        GetNodes200Response.initialize(this, node, garageVersion, garageFeatures, rustVersion, dbEngine, knownNodes, layout);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, node, garageVersion, garageFeatures, rustVersion, dbEngine, knownNodes, layout) { 
        obj['node'] = node;
        obj['garageVersion'] = garageVersion;
        obj['garageFeatures'] = garageFeatures;
        obj['rustVersion'] = rustVersion;
        obj['dbEngine'] = dbEngine;
        obj['knownNodes'] = knownNodes;
        obj['layout'] = layout;
    }

    /**
     * Constructs a <code>GetNodes200Response</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/GetNodes200Response} obj Optional instance to populate.
     * @return {module:model/GetNodes200Response} The populated <code>GetNodes200Response</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new GetNodes200Response();

            if (data.hasOwnProperty('node')) {
                obj['node'] = ApiClient.convertToType(data['node'], 'String');
            }
            if (data.hasOwnProperty('garageVersion')) {
                obj['garageVersion'] = ApiClient.convertToType(data['garageVersion'], 'String');
            }
            if (data.hasOwnProperty('garageFeatures')) {
                obj['garageFeatures'] = ApiClient.convertToType(data['garageFeatures'], ['String']);
            }
            if (data.hasOwnProperty('rustVersion')) {
                obj['rustVersion'] = ApiClient.convertToType(data['rustVersion'], 'String');
            }
            if (data.hasOwnProperty('dbEngine')) {
                obj['dbEngine'] = ApiClient.convertToType(data['dbEngine'], 'String');
            }
            if (data.hasOwnProperty('knownNodes')) {
                obj['knownNodes'] = ApiClient.convertToType(data['knownNodes'], [NodeNetworkInfo]);
            }
            if (data.hasOwnProperty('layout')) {
                obj['layout'] = ClusterLayout.constructFromObject(data['layout']);
            }
        }
        return obj;
    }


}

/**
 * @member {String} node
 */
GetNodes200Response.prototype['node'] = undefined;

/**
 * @member {String} garageVersion
 */
GetNodes200Response.prototype['garageVersion'] = undefined;

/**
 * @member {Array.<String>} garageFeatures
 */
GetNodes200Response.prototype['garageFeatures'] = undefined;

/**
 * @member {String} rustVersion
 */
GetNodes200Response.prototype['rustVersion'] = undefined;

/**
 * @member {String} dbEngine
 */
GetNodes200Response.prototype['dbEngine'] = undefined;

/**
 * @member {Array.<module:model/NodeNetworkInfo>} knownNodes
 */
GetNodes200Response.prototype['knownNodes'] = undefined;

/**
 * @member {module:model/ClusterLayout} layout
 */
GetNodes200Response.prototype['layout'] = undefined;






export default GetNodes200Response;

